/**
 * \file
 *
 * \brief AVR޲/̂߂̗
 *
 * 쌠 (C) 2016 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
/*
 * xFAQ: <a href="http://www.atmel.com/design-support/">Atmelx</a>q˂ĂB
 */


#include "avr/io.h"
#include "avr/interrupt.h"

#define USER_LED	PORTB5
#define OC2A_PIN	PORTB3

/* ٰ 1 : / - /0 */
void init_Ex1(void)
{
	TCCR0B = (1<<CS02)|(1<<CS00);				// /0 ۯ=I/Oۯ/1024Ŏn
	TIFR0  = 1<<TOV0;							// TOV0=0,ۗ荞݉
	TIMSK0 = 1<<TOIE0;							// /0ꊄ荞݋
}

/* ٰ 2 : ߊl - /1 */
/* PB0(ICP1)ߊl݁Bɂĉ~[ŕߊls */
void init_Ex2(void)
{
	TCCR1B = (1<<CS1)|(1<<CS0);					// /1 ICP1G틖,ۯ=I/Oۯ/64Ŏn
	TIFR1  = 1<<ICF;							// ICF1=0,ۗ荞݉
	TIMSK1 = 1<<ICIE;							// /1ߊl荞݋
}

/* ٰ 3 : /2̔񓯊 */
/* /2p̸ۯTOSC݂ɐڑꂽXtal܂B */
void init_Ex3(void)
{
	ASSR  |= 1<<AS2;							// 񓯊싖
	TCCR2A = (1<<COM2A0)|(1<<WGM21);			// CTC,rvOC2A
	TCCR2B = (1<<CS22)|(1<<CS21)|(1<<CS20);		// 1024(=32768Hz/1024)Ŏn
	OCR2A  = 32;								// rl32ݒ
	while (ASSR & ((1<<OCR2AUB)|(1<<OCR2BUB)|(1<<TCR2AUB)|(1<<TCR2BUB)|(1<<TCN2UB)));	// TC2ڼ޽XV܂őҋ@
	TIFR2  = (1<<TOV2)|(1<<OCF2A)|(1<<OCF2B);	// ۗ荞݉(0)
	TIMSK2 = (1<<OCIE2A);						// /2rAv荞݋
	DDRB  |= (1<<OC2A_PIN);						// PB3/OC2A݂o͂ɐݒ
}

/* ٰ 4 : /2łPWM */
void init_Ex4(void)
{
	TCCR2A = (1<<COM2A1)|(1<<WGM21)|(1<<WGM20);	// 񔽓]8ޯčPWMݒ
	TCCR2B = (1<<CS20);							// OuȂTC2n
	OCR2A  = 0xE0;								// 1/8ޭè(r)lݒ
	DDRB  |= (1<<OC2A_PIN);						// PB3/OC2A݂o͂ɐݒ
}

/* 1 - /0ꊄ荞ݏٰ */
ISR (TIMER0_OVF_vect)
{
	PORTB ^= (1 << USER_LED);					// /0PB5o1/0ݐ؂ւ
}

/* 2 - /1ߊl荞ݏٰ */
ISR (TIMER1_CAPT_vect)
{
	TCNT1  = 0;									// /1(TCNT1)=0AĎn
	PORTB ^= (1 << USER_LED);					// /1ߊlPB5o1/0ݐ؂ւ
}

/* 3 - /2rAv荞ݏٰ */
ISR(TIMER2_COMPA_vect)
{
	PORTB ^= (1<<USER_LED);						// /2rAvPB5o1/0ݐ؂ւ
}

int main (void)
{
	DDRB = (1 << USER_LED);						// PB5݂o͂ɐݒ

	// 1ɑ΂Ă͎sA̗ɑ΂Ă͋֎~ĂB
	init_Ex1();
	// 2ɑ΂Ă͎sA̗ɑ΂Ă͋֎~ĂB
//	init_Ex2();
	// 3ɑ΂Ă͎sA̗ɑ΂Ă͋֎~ĂB
//	init_Ex3();
	// 4ɑ΂Ă͎sA̗ɑ΂Ă͋֎~ĂB
//	init_Ex4();

	sei();										// S̊荞݋

	for (;;){}									// I薳JԂ
	return 0;
}
